#
# (ɤ)ץ Bread  桼󥿥ե Apollo 
#
# by Noritsugu Nakamura

require 'phi'
require 'dialogs'
require 'kconv'

include  Phi 

# Tk ߴ󥿥ե
module Phi
  def tr(txt)
    Kconv::tosjis(txt)
  end

  class Label
    def text(txt)
      self.caption=(tr(txt))
    end
  end
  class Edit
    def value
      Kconv::toeuc(self.text)
    end
    def value=(txt)
      self.text=(tr(txt))
    end
  end
end

class Phi_Help < Phi::Form
  def initialize(com_name, title, text)
    super(com_name, tr(title))
    self.width = 700
    self.height = 500
    self.border_style
    self.position = Phi::PO_MAIN_FORM_CENTER
    self.auto_scroll = false
    self.caption = tr(title)

    margin = 10

    ok = Phi::Button.new(self, :ok1, tr('λ'))
    ok.top = self.height - ok.height * 2 - margin # ?
    ok.left = self.width - ok.width - margin

    #memo = Memo.new self, :memo, text
    memo = Memo.new self, :memo, ''
    #memo.want_returns = true
    memo.scroll_bars = Phi::SS_VERTICAL
    memo.top = 0
    memo.left = 0
    memo.width = self.width - margin
    memo.height = self.height - ok.height - margin - 30
    text.each {|line| memo.lines.add(tr(line.chomp))}

    ok.on_click = proc { close }
    #self.parent.on_close = proc { close }

    # Windows ꥵ
    self.on_resize = proc do
      memo.width = self.width - margin
      memo.height = self.height - ok.height - margin - 30

      ok.top = self.height - ok.height * 2 - margin # ?
      ok.left = self.width - ok.width - margin
    end

    self.on_show = proc do
      memo.set_focus
    end
  end
end

module UI_Apollo
  class Variable
    def initialize
      @value = ""
    end
    def value=(v)
      @value = v
    end
    attr_reader :value
  end

  COURSE = Variable.new

  def init
    # ȥȥ󲽤Υȥ
    form = Form.new
    form.caption = tr(TITLE)
    form.width = 370
    form.height = 410
    #form.border_icons = Phi::BI_MINIMIZE

    # ˥塼
    Phi.new_menu form, :menu, [
      Phi.new_item('&File', '', :mi_file).add(
        Phi.new_item(tr('λ'), 'Ctrl+Q', :mi_quit)
      ),
      Phi.new_item('&Course', '', :mi_course).add(
        Phi.new_item(tr('50ѹ'),   '', :mi_course1, true),
        Phi.new_item(tr('ٹѹ'),   '', :mi_course2),
        Phi.new_item(tr('ü첻ѹ'), '', :mi_course3),
        Phi.new_item(tr('ѹ'), '', :mi_course4),
        Phi.new_item(tr('ե٥åȤѹ'), '', :mi_course5),
        Phi::new_line,
        Phi.new_item(tr('̤ѹ'), '', :mi_outotu)
      ),
      Phi.new_item('&Help', '', :mi_help).add(
        Phi.new_item('&About...',  '', :mi_about),
        Phi.new_item(tr('Ȥ'),     '', :mi_usage),
        Phi.new_item(tr('ɽ'), '', :mi_exp_braille)
      )
    ]
    
    form.mi_quit.on_click = proc { exit }

    form.mi_course1.radio_item = true
    form.mi_course2.radio_item = true
    form.mi_course3.radio_item = true
    form.mi_course4.radio_item = true
    form.mi_course5.radio_item = true
    form.mi_course1.group_index = 0
    form.mi_course2.group_index = 0
    form.mi_course3.group_index = 0
    form.mi_course4.group_index = 0
    form.mi_course5.group_index = 0
    
    form.mi_course1.on_click = proc do
      form.mi_course1.checked = true unless form.mi_course1.checked?
      change_course("50")
    end
    form.mi_course2.on_click = proc do
      form.mi_course2.checked = true unless form.mi_course2.checked?
      change_course("ٹ")
    end
    form.mi_course3.on_click = proc do
      form.mi_course3.checked = true unless form.mi_course3.checked?
      change_course("ü첻")
    end
    form.mi_course4.on_click = proc do
      form.mi_course4.checked = true unless form.mi_course4.checked?
      change_course("")
    end
    form.mi_course5.on_click = proc do
      form.mi_course5.checked = true unless form.mi_course5.checked?
      change_course("ե٥å")
    end
    form.mi_outotu.on_click  = proc do
      change_outotu()
    end

    form.mi_about.on_click = proc do
      Phi::message_dlg(tr(COPYRIGHT), Phi::MT_INFORMATION, [Phi::MB_OK], 0)
    end

    form.mi_usage.on_click = proc do
      usage
    end

    form.mi_exp_braille.on_click = proc do
      exp_braille
    end

    # ᥤ
    title = Label.new form, :title, ""
    title.top = 20; title.left = 20; title.font.height = 18
    #title.align = Phi::AL_CLIENT
    #title.left = (form.width - title.width) / 2
    @title = title

    braille1 = Label.new form, :braille1, ""
    braille1.top = 70; braille1.left = 150; braille1.font.height = 24
    @braille1 = braille1

    braille2 = Label.new form, :braille2, ""
    braille2.top = 110; braille2.left = 150; braille2.font.height = 24
    @braille2 = braille2

    braille3 = Label.new form, :braille3, ""
    braille3.top = 150; braille3.left = 150; braille3.font.height = 24
    @braille3 = braille3

    entry = Edit.new form, :entry, ""
    entry.width = 160
    entry.top = 200; entry.left = 110; entry.font.height = 20
    @entry = entry

    yosidame = Label.new form, :yosidame, ""
    yosidame.top = 250; yosidame.left = 60; yosidame.font.height = 18
    @yosidame = yosidame

    yosi = Label.new form, :yosi, tr("")
    yosi.top = 300; yosi.left = 60; yosi.font.height = 22

    l_yosi = Label.new form, :l_yosi, "0"
    l_yosi.top = 300; l_yosi.left = 120; l_yosi.font.height = 22
    @l_yosi = l_yosi

    dame = Label.new form, :dame, tr("")
    dame.top = 300; dame.left = 220; dame.font.height = 22

    l_dame = Label.new form, :l_dame, "0"
    l_dame.top = 300; l_dame.left = 280; l_dame.font.height = 22
    @l_dame = l_dame

    form.show

    form.entry.on_key_press = proc do |sender, key|
      if key == 13
        # ٥
        key = 0
        answer_check
      end
      key # [ap-list:2618]
    end

    # ץबλ Help Window ä
    form.on_close = proc do
      $w_usage.close if $w_usage
      $w_exp.close if $w_exp        
    end

    # ΤȤ˥ե
    # ʤ
    entry.set_focus
  end

  def main_loop
    mainloop
  end

  # [ap-list:2617]
  def sleep_sec(sec)
    last = Time.now + sec
    APPLICATION.process_messages while Time.now < last
  end

  def sleep_
    sleep_sec(2)

    nextq
  end

  # Ȥ
  def usage
    # widget ¸ߤ˴
    # hide ȤȤФʤɤ
    if $w_usage
      $w_usage.close
    end
    $w_usage = Phi_Help.new(:dlg1, "Ȥ", Bread::USAGE)
    $w_usage.show
  end

  # ɽ
  def exp_braille
    # widget ¸ߤ˴
    # hide ȤȤФʤɤ
    if $w_exp
      $w_exp.close
    end
    $w_exp = Phi_Help.new(:dlg2, "ɽ", Bread::TABLE)
    $w_exp.show
  end
end
