#
# (ɤ)ץ Bread  桼󥿥ե Gnome 
#
# by Noritsugu Nakamura

require "gtk"
require 'gdk_imlib'
require 'gnome'

# Tk ߴ󥿥ե
module Gtk
  class Label
    alias text set_text
  end
  class Entry
    alias value get_text
    alias value= set_text
  end
end

class Gtk_Help < Gtk::Window
  def initialize(title, text_)
    super(Gtk::WINDOW_TOPLEVEL)
    set_usize(700, 500)
    set_title(title)
    border_width(0)
    signal_connect("destroy") do false end

    box = Gtk::VBox.new(false, 0)
    add(box)
    box.show

    less = Gnome::Less.new
    less.set_fixed_font(true)
    less.show_string(text_)
    less.show
    box.pack_start(less, true, true, 0)

    button = Gtk::Button.new("Ĥ")
    button.signal_connect("clicked") do destroy end
    box.pack_start(button, false, true, 0)
    button.set_flags(Gtk::Widget::CAN_DEFAULT)
    #button.grab_default
    button.show

    show
  end
end

module UI_Gnome
  class Variable
    def initialize
      @value = ""
    end
    def value=(v)
      @value = v
    end
    attr_reader :value
  end
  COURSE = Variable.new

  def init
    # ȥȥ󲽤Υȥ
    window = Gnome::App.new("bread", TITLE)
    window.realize
    #window.set_icon_name(ICON_TITLE)
    window.set_usize(300, 0)
    window.signal_connect('destroy') {
      exit
    }
    window.signal_connect('delete_event') {
      false
    }

    # Υե졼
    vbox = Gtk::VBox.new(false, 5)
    window.set_contents(vbox)
    vbox.show

    # ˥塼
    file_menu = [
#      Gnome::UIInfo::item_stock("Exit",
#        nil, proc { Gtk::main_quit },
#        Gnome::Stock::MENU_QUIT),
      [ Gnome::App::UI_ITEM, "Exit", nil, proc{ Gtk::main_quit }, nil,
        Gnome::App::PIXMAP_STOCK, Gnome::Stock::MENU_EXIT, ?Q,
        Gdk::CONTROL_MASK, nil ],
    ]
    radio_items = [
      [ Gnome::App::UI_ITEM, "50ѹ", nil,
        proc { change_course("50") }, nil,
        Gnome::App::PIXMAP_NONE, nil, 0, 0, nil ],
      [ Gnome::App::UI_ITEM, "ٹѹ", nil,
        proc { change_course("ٹ") }, nil,
        Gnome::App::PIXMAP_NONE, nil, 0, 0, nil ],
      [ Gnome::App::UI_ITEM, "ü첻ѹ", nil,
        proc { change_course("ü첻") }, nil,
        Gnome::App::PIXMAP_NONE, nil, 0, 0, nil ],
      [ Gnome::App::UI_ITEM, "ѹ", nil,
        proc { change_course("") }, nil,
        Gnome::App::PIXMAP_NONE, nil, 0, 0, nil ],
      [ Gnome::App::UI_ITEM, "ե٥åȤѹ", nil,
        proc { change_course("ե٥å") }, nil,
        Gnome::App::PIXMAP_NONE, nil, 0, 0, nil ],
    ]
    course_menu = [
      Gnome::UIInfo::radiolist(radio_items),
      Gnome::UIInfo::separator,
      Gnome::UIInfo::item_stock("̤ѹ",
        nil, proc { change_outotu() }, nil),
    ]
    help_menu = [
      Gnome::UIInfo::item_stock("About ...",
        nil, proc { help_about },
        Gnome::Stock::MENU_ABOUT),
      Gnome::UIInfo::item_stock("Ȥ",
        nil, proc { usage }, nil),
      Gnome::UIInfo::item_stock("ɽ",
        nil, proc { exp_braille } , nil),
    ]
    main_menu = [
      Gnome::UIInfo::subtree("_File", file_menu),
      Gnome::UIInfo::subtree("_Course", course_menu),
      Gnome::UIInfo::subtree("_Help", help_menu) ]
    window.create_menus(main_menu)

    # ᥤ
    @title = Gtk::Label.new(" 50  ")
    vbox.pack_start @title, true, true, 10
    @title.show

    @braille1 = Gtk::Label.new("")
    vbox.pack_start @braille1, true, true, 0
    @braille1.show

    @braille2 = Gtk::Label.new("")
    vbox.pack_start @braille2, true, true, 0
    @braille2.show

    @braille3 = Gtk::Label.new("")
    vbox.pack_start @braille3, true, true, 0
    @braille3.show

    # 
    hbox = Gtk::HBox.new(false, 10)
    vbox.pack_start hbox, true, true, 20
    hbox.show

    @entry = Gtk::Entry.new()
    hbox.pack_start @entry, true, false, 0
    @entry.show

    @yosidame = Gtk::Label.new("")
    vbox.pack_start @yosidame, true, true, 0
    @yosidame.show
      
    hbox = Gtk::HBox.new(true, 0)
    vbox.pack_start hbox, true, true, 10
    hbox.show

    yoshi = Gtk::Label.new("")
    hbox.pack_start yoshi, true, false, 0
    yoshi.show
    
    @l_yosi = Gtk::Label.new("0")
    hbox.pack_start @l_yosi, true, false, 0
    @l_yosi.show

    dame = Gtk::Label.new("")
    hbox.pack_start dame, true, false, 0
    dame.show

    @l_dame = Gtk::Label.new("0")
    hbox.pack_start @l_dame, true, false, 0
    @l_dame.show

    window.show

    # Х
    @entry.signal_connect('activate') {
      answer_check
    }
      
    # ΤȤ˥ե
    window.set_focus(@entry)
  end

  def main_loop
    Gtk.main
  end

  def sleep_
    #sleep 2
    time = Time.new
    Gtk::timeout_add(2000) do
      if (Time.new - time) > 2
        nextq
        false
      else
        true
      end
    end

    #nextq
  end

  # About
  def help_about
    Gnome::About.new(
      "Bread",
      "#{BREAD_VERSION}",
      "(C) 2000-2002 #{AUTHOR}",
      [ "#{AUTHOR}" ],
      "Bread is a software for training of reading braille").show
  end

  # Ȥ
  def usage
    # widget ¸ߤ˴
    if $w_usage
      $w_usage.destroy
    end
    $w_usage = Gtk_Help.new("Ȥ", Bread::USAGE)
  end
  
  # ɽ
  def exp_braille
    # widget ¸ߤ˴
    if $w_exp
      $w_exp.destroy
    end
    $w_exp = Gtk_Help.new("ɽ", Bread::TABLE)
  end
end
