#
# (ɤ)ץ Bread  桼󥿥ե Gtk 
#
# by Noritsugu Nakamura

require "gtk"
require "uconv" if RUBY_PLATFORM =~ /(cygwin|mingw)/

def set_font
  return unless RUBY_PLATFORM =~ /(cygwin|mingw)/
  fontset = "-*-*-*-*-*-*-18-*-*-*-*-*-jisx0208.1983-*"
  Gtk::RC.parse_string <<EOM
style "default"
{fontset = "#{fontset}" }
widget_class "*" style "default"
EOM
end

# EUC --> UTF8
def tr(txt)
  if RUBY_PLATFORM =~ /(cygwin|mingw)/
    Uconv.euctou8(txt)
  else
    txt
  end
end

# Tk ߴ󥿥ե
module Gtk
  class Label
    def text(txt)
      if RUBY_PLATFORM =~ /(cygwin|mingw)/
        self.set_text(Uconv.euctou8(txt))
      else
        self.set_text(txt)
      end
    end
  end
  class Entry
    def value
      if RUBY_PLATFORM =~ /(cygwin|mingw)/
        Uconv.u8toeuc(self.get_text)
      else
        self.get_text
      end
    end
    alias value= set_text
  end
end

# About 
class Dialog < Gtk::Dialog
  def initialize(title)
    super()
    set_modal(true)
    set_usize(250, 170)
    set_title(tr(title))
    signal_connect("destroy") do false end

    label = Gtk::Label::new(tr(COPYRIGHT))
    vbox.pack_start(label)
    label.show

    button = Gtk::Button::new("OK")
    button.flags |= Gtk::Widget::CAN_DEFAULT
    button.signal_connect("clicked") do destroy end
    action_area.pack_start(button)
    button.grab_default
    button.show

    show
  end
end

class Gtk_Help < Gtk::Window
  def initialize(title, text_)
    super(Gtk::WINDOW_TOPLEVEL)
    set_usize(700, 500)
    set_title(tr(title))
    border_width(0)
    signal_connect("destroy") do false end

    box = Gtk::VBox.new(false, 0)
    add(box)
    box.show

    scrolled_window = Gtk::ScrolledWindow.new(nil, nil)
    box.pack_start(scrolled_window, true, true, 0)
    scrolled_window.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_ALWAYS)
    scrolled_window.show

    text = Gtk::Text.new(nil, nil)
    text.set_editable(false)
    scrolled_window.add(text)
    text.grab_focus
    text.show

    text.insert(nil, nil, nil, tr(text_))

    button = Gtk::Button.new(tr("Ĥ"))
    button.signal_connect("clicked") do destroy end
    box.pack_start(button, false, true, 0)
    button.set_flags(Gtk::Widget::CAN_DEFAULT)
    #button.grab_default
    button.show

    show
  end
end

module UI_Gtk
  class Variable
    def initialize
      @value = ""
    end
    def value=(v)
      @value = v
    end
    attr_reader :value
  end
  COURSE = Variable.new
  def init
    set_font

    # ȥȥ󲽤Υȥ
    window = Gtk::Window.new(Gtk::WINDOW_TOPLEVEL)
    window.set_title(TITLE)
    #window.set_icon_name(ICON_TITLE)
    window.set_usize(300, 0)
    window.signal_connect('destroy') {
      exit
    }
    window.signal_connect('delete_event') {
      false
    }

    # Υե졼
    vbox = Gtk::VBox.new(false, 5)
    window.add(vbox)
    vbox.show

    # ˥塼
    accel = Gtk::AccelGroup.new
    accel.attach(window)
    course = [
      proc { change_course("50") },
      proc { change_course("ٹ") },
      proc { change_course("ü첻") },
      proc { change_course("") },
      proc { change_course("ե٥å") }
    ]
    outotu = proc{ change_outotu() }
    help_about = Proc.new { Dialog.new("About") }
    help_usage = Proc.new { usage }
    help_exp_braille = Proc.new { exp_braille }
    quit = Proc.new{ Gtk.main_quit }

    ifp = Gtk::ItemFactory.new(Gtk::ItemFactory::TYPE_MENU_BAR, "<main>", accel)
    ifp.create_items(
[[tr("/ե(_F)"),                              nil,                 Gtk::ItemFactory::BRANCH,       nil,        nil],
 [tr("/ե(_F)/ѥ졼"),                   nil,                 Gtk::ItemFactory::SEPARATOR,    nil,        nil],
 [tr("/ե(_F)/λ(_Q)"),                     "<control>Q",        nil,                            quit,       nil],
 [tr("/(_C)"),                                nil,                 Gtk::ItemFactory::BRANCH,       nil,        nil],
 [tr("/(_C)/50ѹ"),               nil,                 Gtk::ItemFactory::RADIO_ITEM,   course[0],  nil],
 [tr("/(_C)/ٹѹ"),               nil,                 tr("/(C)/50ѹ"),  course[1],  nil],
 [tr("/(_C)/ü첻ѹ"),             nil,                 tr("/(C)/50ѹ"),  course[2],  nil],
 [tr("/(_C)/ѹ"),               nil,                 tr("/(C)/50ѹ"),  course[3],  nil],
 [tr("/(_C)/ե٥åȤѹ"),     nil,                 tr("/(C)/50ѹ"),  course[4],  nil],
 [tr("/(_C)/ѥ졼"),                     nil,                 Gtk::ItemFactory::SEPARATOR,    nil,        nil],
 [tr("/(_C)/̤ѹ"),                 nil,                 nil,                            outotu,     nil],
 [tr("/إ(_H)"),                                nil,                 Gtk::ItemFactory::LAST_BRANCH,  nil,        nil],
 [tr("/إ(_H)/About..."),                       "F1",                 nil,                            help_about, nil],
 [tr("/إ(_H)/Ȥ"),                         nil,                 nil,                            help_usage, nil],
 [tr("/إ(_H)/ɽ"),                     nil,                 nil,                            help_exp_braille, nil],])

    menubar = ifp.get_widget("<main>") 
    vbox.pack_start menubar, false, false, 0
    menubar.show

    # ᥤ
    @title = Gtk::Label.new(" 50  ")
    vbox.pack_start @title, true, true, 10
    @title.show

    @braille1 = Gtk::Label.new("")
    vbox.pack_start @braille1, true, true, 0
    @braille1.show

    @braille2 = Gtk::Label.new("")
    vbox.pack_start @braille2, true, true, 0
    @braille2.show

    @braille3 = Gtk::Label.new("")
    vbox.pack_start @braille3, true, true, 0
    @braille3.show

    # 
    hbox = Gtk::HBox.new(false, 10)
    vbox.pack_start hbox, true, true, 20
    hbox.show

    @entry = Gtk::Entry.new()
    hbox.pack_start @entry, true, false, 0
    @entry.show

    @yosidame = Gtk::Label.new("")
    vbox.pack_start @yosidame, true, true, 0
    @yosidame.show
      
    hbox = Gtk::HBox.new(true, 0)
    vbox.pack_start hbox, true, true, 10
    hbox.show

    yoshi = Gtk::Label.new(tr(""))
    hbox.pack_start yoshi, true, false, 0
    yoshi.show
    
    @l_yosi = Gtk::Label.new("0")
    hbox.pack_start @l_yosi, true, false, 0
    @l_yosi.show

    dame = Gtk::Label.new(tr(""))
    hbox.pack_start dame, true, false, 0
    dame.show

    @l_dame = Gtk::Label.new("0")
    hbox.pack_start @l_dame, true, false, 0
    @l_dame.show

    window.show

    # Х
    @entry.signal_connect('activate') {
      answer_check
    }
      
    # ΤȤ˥ե
    window.set_focus(@entry)
  end

  def main_loop
    Gtk.main
  end

  def sleep_
    #sleep 2
    time = Time.new
    Gtk::timeout_add(2000) do
      if (Time.new - time) > 2
        nextq
        false
      else
        true
      end
    end

    #nextq
  end

  # Ȥ
  def usage
    # widget ¸ߤ˴
    if $w_usage
      $w_usage.destroy
    end
    $w_usage = Gtk_Help.new("Ȥ", Bread::USAGE)
  end
  
  # ɽ
  def exp_braille
    # widget ¸ߤ˴
    if $w_exp
      $w_exp.destroy
    end
    $w_exp = Gtk_Help.new("ɽ", Bread::TABLE)
  end
end
